/* 
 * Copyright (C) 1999-2004 Joachim Wieland <joe@mcknight.de>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111, USA.
 */

#ifndef __JPROXYGW_SOCKETS_H__
#define __JPROXYGW_SOCKETS_H__

int openlocalport(struct sockaddr_in *, unsigned long int local_addr,
		  struct portrangestruct *, struct proxyinfo*);
int openportiaddr(unsigned long, unsigned int, unsigned long int,
		  const struct portrangestruct*, struct proxyinfo*);
int openportname(const char*, unsigned int, unsigned long int,
		 const struct portrangestruct*, struct proxyinfo*);
unsigned long int  socketinfo_get_local_addr_by_sending(int, struct proxyinfo*);
struct sockaddr_in socketinfo_get_local_sin(int);
unsigned long int  socketinfo_get_local_ip(int);
unsigned int       socketinfo_get_local_port(int);
struct sockaddr_in socketinfo_get_transparent_target_sin(int);
struct address_t   socketinfo_get_transparent_target(int);

int transfer_wait_connection(int*, int*);

#endif
